#ifndef DIRICHLETBC2D_H
#define DIRICHLETBC2D_H

#include <set>
#include "point2d.h"

/** DirichletBC2D:
 *      Provides an interface for information about the Dirichlet boundary.
 */
class DirichletBC2D{

public:
    DirichletBC2D(){}
    
    /** Returns whether point x is on the dirichlet boundary or not
     *  (Abstract function that has to be implemented in each derived class)
     */
    virtual
    bool
    is_Dirichlet_point(Point2D& x) = 0; 
 

};


#endif // DIRICHLETBC2D_H