#ifndef POLYGON_H
#define POLYGON_H 1


//This is a general class for the storage of poygons. It assumes that there is a list of coordinates somewhere outside this class,
//as it only stores the position (this is why we have an int * !) of the coordinate in the coordinate list.
//As we only want to use this class only for triangle, you can also implement it less general (but call it Triangle then), i.e. as int[3]
class Polygon{

public:
	int N;
	int * nodes;

	//Default-Constructor
	Polygon();

	//Constructor (this is not needed if you only do it for triangles)
	Polygon(const int numberofedges);

	//Copy-Constructor
	Polygon(const Polygon &copy);

	//Destructor
	~Polygon();

	//Defined this was this operator can be used for assignment as well as evaluation!
	int &
	operator[](const int pos);

	//Assignment-Operator
	Polygon & 
	operator=(const Polygon & copy);
};


Polygon::Polygon():N(1),nodes(0){
	nodes = new int[N];
	for(int i = 0; i < N; ++i){
		nodes[i] = -1;
	}
}

Polygon::Polygon(const int numberofedges):N(numberofedges),nodes(0){
	nodes = new int[N];
	for(int i = 0; i < N; ++i){
		nodes[i] = -1;
	}
}



Polygon::Polygon(const Polygon &copy):N(copy.N),nodes(0){
	nodes = new int[N];
	for(int i = 0; i < N; ++i){
		nodes[i] = copy.nodes[i];
	}
}

Polygon::~Polygon(){
	if(nodes != 0){
		delete[] nodes;
		nodes = 0;
	}
}

int &
Polygon::operator[](const int pos){
	return nodes[pos];
}

Polygon & 
Polygon::operator=(const Polygon & copy){
	N = copy.N;
	if(nodes != 0){
		delete [] nodes;
	}
	nodes = new int[N];
	for(int i = 0; i < N; ++i){
		nodes[i] = copy.nodes[i];
	}
	return *this;
}




#endif //PolygonS_H